VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "Tree Builder"
   ClientHeight    =   5940
   ClientLeft      =   10035
   ClientTop       =   825
   ClientWidth     =   5145
   Icon            =   "tree_builder.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5940
   ScaleWidth      =   5145
   Begin MSComctlLib.ImageList imgList 
      Left            =   840
      Top             =   5280
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   1
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "tree_builder.frx":0442
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton cmdParse 
      Caption         =   "&Parse"
      Height          =   495
      Left            =   2040
      TabIndex        =   5
      Top             =   5280
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog cmdOpenFileDialog 
      Left            =   120
      Top             =   5280
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   495
      Left            =   3720
      TabIndex        =   4
      Top             =   5280
      Width           =   1335
   End
   Begin MSComctlLib.TreeView trvFiles 
      Height          =   3735
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   4935
      _ExtentX        =   8705
      _ExtentY        =   6588
      _Version        =   393217
      LineStyle       =   1
      Sorted          =   -1  'True
      Style           =   7
      ImageList       =   "imgList"
      BorderStyle     =   1
      Appearance      =   1
      MouseIcon       =   "tree_builder.frx":0894
   End
   Begin VB.Frame Frame1 
      Caption         =   "File name"
      Height          =   975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4935
      Begin VB.CommandButton cmdOpenFile 
         Caption         =   "..."
         Height          =   375
         Left            =   4320
         TabIndex        =   2
         Top             =   360
         Width           =   375
      End
      Begin VB.TextBox txtFileName 
         Height          =   375
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   3855
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
      End
      Begin VB.Menu mnuFileBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptionsOptions 
         Caption         =   "&Options..."
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub parse_the_files()
      
   'Find the MATLABRC file and read all the directories
   On Error GoTo no_matlab_file_found
   Dim directories() As String
   ReDim directories(0)
   
   Close
   matlab_dirs_file = Trim(matlab_dirs_file)
   Open matlab_dirs_file For Input As 1
   
   matlabpath = Left(matlab_dirs_file, InStrRev(matlab_dirs_file, "toolbox") - 2)
      
   'Discard the first lines of the file
   s = ""
   While (Not EOF(1)) And (InStr(s, "p = [...") <> 1)
        Line Input #1, s
   Wend
   
   'Read all the paths
   While Not EOF(1)
        Line Input #1, s
        If (InStr(s, "\")) Then
            s = Trim(s)
            s = Right(s, Len(s) - 1)
            If (InStr(s, "matlabroot")) Then
                'Replace the matlabroot
                s = Replace(s, "matlabroot,'", matlabpath)
            Else
                s = Right(s, Len(s) - 1)
            End If
            s = Left(s, Len(s) - 6)
            ReDim Preserve directories(UBound(directories) + 1)
            directories(UBound(directories)) = s
        End If
   Wend
   
   Close
   
   'Add the current directory
   ReDim Preserve directories(UBound(directories) + 1) As String
   directories(UBound(directories)) = CurDir
   
   On Error GoTo 0
   Load frmProgress
   frmProgress.show
   frmProgress.Refresh
   
   'Move over all the files in functions() and parse them
   all_parsed = False
   
   While (all_parsed = False)
        'Check if all the functions were parsed, if not, find the first
        'occurence of a file that wasn''t
        all_parsed = True
        parse_count = 0
        total_funcs = 0
        For i = 1 To UBound(functions)
            If functions(i).called_function <> "" Then
              total_funcs = total_funcs + 1
            End If
            If functions(i).parsed = False Then
                'Check if the function has not been called from somewhere else. If it has,
                'mark it as such, instead of reparsing the file
                need_parsing = True
                For j = 1 To UBound(functions)
                    If functions(j).called_function = functions(i).called_function And _
                       functions(j).calling_function <> functions(i).calling_function _
                       And functions(j).parsed = True And i <> j Then
                       functions(i).parsed_function = functions(j).calling_function
                       functions(i).parsed = True
                       need_parsing = False
                       Exit For
                    End If
                Next
                If need_parsing = True Then
                   unparsed = i
                   all_parsed = False
                End If
            Else
                'If this is a function (not a variable) then count it
                If functions(i).called_function <> "" Then
                   parse_count = parse_count + 1
                End If
            End If
        Next
        frmProgress.lblProgress.Caption = "Parsed " & parse_count & " files out of " & total_funcs & "."
        frmProgress.Refresh
        
        If Not (all_parsed) Then
            parse_function = functions(unparsed).called_function
            functions(unparsed).parsed = True
            
            If Right(parse_function, 2) <> ".m" Then
               parse_function = parse_function & ".m"
            End If
               
            On Error GoTo bad_file
            get_out = False
            'Find where the function to be parsed is
            filedir = ""
            For i = 1 To UBound(directories)
                filedir = Dir(directories(i) & "\" & parse_function)
                If get_out = True Then
                   Exit For
                End If
                If filedir <> "" Then
                    filedir = directories(i) & "\" & parse_function
                    Exit For
                End If
            Next
            
            On Error GoTo 0
            If filedir <> "" Then
                'Open the file for parsing
                Open filedir For Input As 1
                
                line_number = 0
                'Parse the file, adding functions to the functions array
                While Not (EOF(1))
                    Line Input #1, s
                    line_number = line_number + 1
                    s = LCase(Trim(s))
                    
                    'If the line ends with ..., read another line
                    While Right(Trim(s), 3) = "..." And Not (EOF(1))
                        Line Input #1, s1
                        s = Left(s, Len(s) - 3) & s1
                    Wend
                    
                    'Discard the line if it begins with "function"
                    If Left(s, 8) = "function" Then
                       s = ""
                    End If
                    
                    'Change all tabs to spaces
                    s = Replace(s, Chr(9), " ")
                    
                    'Discard all text between the ''
                    'The ' is an operand only if it comes not after an operand
                    If InStr(s, "'") > 0 Then
                        
                        'If the line is a comment, disreguard it
                        If Left(Trim(s), 1) = "%" Then
                           s = ""
                        End If
                        
                        i = 1
                        too_long = False
                        While (i < Len(s) And Not (too_long))
                            
                            'Against infinite loops, if you get into one, kill the whole line
                            If i > 1024 Then
                               s = ""
                               too_long = True
                            End If
                               
                            If Mid(s, i, 1) = "'" Then
                                If InStr(operand & "([{", Mid(s, i - 1, 1)) > 0 Then
                                    'Find a closing bracket and discard between them
                                    s = Left(s, i - 1) & Right(s, Len(s) - InStr(i + 1, s, "'"))
                                    i = 1
                                End If
                            End If
                            i = i + 1
                        Wend
                    End If
                    
                    'Discard from the point of a %
                    pointer = InStr(s, "%")
                    If pointer > 0 Then
                       s = Left(s, pointer - 1)
                    End If

                    'Discard until a "=" if it exists, but without a "for"
                    pointer = InStr(s, "=")
                    If pointer > 0 Then
                       If Mid(s, pointer, 2) <> "==" Then
                          for_pointer = InStr(s, "for")
                          If for_pointer > 0 Then
                             'There is a for command, so add it
                             Call add_function(parse_function, "For", Int(line_number))
                          End If
                          s = Right(s, Len(s) - pointer)
                       End If
                    End If
                                                            
                    'Discard brackets and ;
                    s = Replace(s, "[", " ")
                    s = Replace(s, "]", " ")
                    s = Replace(s, "{", " ")
                    s = Replace(s, "}", " ")
                    s = Replace(s, ";", " ")
                    
                    'Now start parsing
                    Call parse_line(s, parse_function, Int(line_number))
                Wend
                
                Close 1
            Else
                'There is no such function, so it's probibly a variable, in this case, discard it
                functions(unparsed).called_function = ""
                functions(unparsed).calling_function = ""
            End If
                
        End If
        
   Wend
   
   'Now put all the functions of the tree, according to the calling functions
   'and add the number of times each function s called
   
   For i = 1 To UBound(functions)
       'First, remove all the ".m"'s
       If Right(functions(i).called_function, 2) = ".m" Then
          functions(i).called_function = Left(functions(i).called_function, Len(functions(i).called_function) - 2)
       End If
       If Right(functions(i).calling_function, 2) = ".m" Then
          functions(i).calling_function = Left(functions(i).calling_function, Len(functions(i).calling_function) - 2)
       End If
       If Right(functions(i).parsed_function, 2) = ".m" Then
          functions(i).parsed_function = Left(functions(i).parsed_function, Len(functions(i).parsed_function) - 2)
       End If
       'Discard all the functions that the user doesn"t want to see
       For j = 1 To UBound(discardable)
           If (functions(i).called_function = discardable(j).function_name) And _
              (discardable(j).show = False) Then
              functions(i).called_function = ""
              functions(i).calling_function = ""
           End If
       Next
   Next

   
   '...and build the tree
   frmProgress.lblProgress.Caption = "Building the function tree"
   frmProgress.Refresh
   
   trvFiles.Nodes.Clear
   Dim nodX As Node
   Set nodX = trvFiles.Nodes.Add(, , functions(1).called_function, functions(1).called_function, 1)
   
   Call add_leaves(functions(1).called_function, trvFiles.Nodes.Count)
   
   Unload frmProgress
   
Exit Sub
no_matlab_file_found:
    MsgBox "pathdef file not found, cannot continue", vbCritical + vbOKOnly ' err
    Exit Sub
    
bad_file:
    filedir = ""
    get_out = True
    Resume Next
    
End Sub
Private Sub add_leaves(base_function As Variant, unique_identifier As Variant)
    
    'Add all the leaves that correspond to the base function, and recursively call this function
    For i = 1 To UBound(functions)
        If functions(i).calling_function = base_function Then
            Dim nodX As Node
            On Error GoTo err_handle
            s = functions(i).called_function & " (" & functions(i).line_number & ")"
            If functions(i).parsed_function <> "" Then
               s = s & " - Also called by " & functions(i).parsed_function
            End If
            Set nodX = trvFiles.Nodes.Add(unique_identifier, tvwChild, , s, 1)
            
            If functions(i).parsed_function = "" Then
               Call add_leaves(functions(i).called_function, trvFiles.Nodes.Count)
            End If
            
        End If
    Next
    
Exit Sub
err_handle:
Select Case Err
Case 35602
    Resume Next
Case 28
    MsgBox "Out of stack space. Some functions may not be displayed", vbOKOnly + vbCritical
    
    Exit Sub
Case Else
   MsgBox Err
   Resume Next
End Select
End Sub
Private Sub parse_line(line As Variant, calling_function As Variant, line_number As Integer)
    
    'If the line is empty, stop the recursion
    If line = "" Then
       Exit Sub
    End If
       
    'Parse a line recursively
    operand_pointer = Len(operand)
    bracket_pointer = InStr(line, "(")
    
    For i = 1 To Len(operand)
        location = InStr(line, Mid(operand, i, 1))
        If location > 0 And location < operand_pointer Then
            operand_pointer = location
        End If
    Next
    location = InStr(line, "==")
    If location > 0 And location < operand_pointer Then
       operand_pointer = location
    End If
        
    If operand_pointer = Len(operand) Then
       operand_pointer = 0
    End If
       
    If operand_pointer = 0 And bracket_pointer = 0 Then
        'No brackets or operands, so add the whole line as a function
        Call add_function(calling_function, Trim(line), line_number)
    Else
        If operand_pointer = 0 Then
            operand_pointer = 1000
        End If
        If bracket_pointer = 0 Then
            bracket_pointer = 1000
        End If
            
        If operand_pointer < bracket_pointer Then
            'There is an operand first
            'So: send what is before and what is after the operand for parsing
            Call parse_line(Trim(Left(line, operand_pointer - 1)), calling_function, line_number)
            Call parse_line(Trim(Right(line, Len(line) - operand_pointer)), calling_function, line_number)
        Else
            'There is a bracket first
            'So: send what is inside the brackets for paring,
            'send  what is after the brackets for parsing
            'Add what is before the brackets as a function (if it is not null)
            closing_brackets = find_closing_brackets(line, Int(bracket_pointer))
            If Trim(Left(line, bracket_pointer - 1)) <> "" Then
               Call add_function(calling_function, Trim(Left(line, bracket_pointer - 1)), line_number)
            End If
            Call parse_line(Trim(Mid(line, bracket_pointer + 1, closing_brackets - bracket_pointer - 1)), calling_function, line_number)
            Call parse_line(Trim(Right(line, Len(line) - closing_brackets)), calling_function, line_number)
        End If
    End If
    
End Sub
Private Function find_closing_brackets(line As Variant, start_from As Integer)
    'Find the closing brackets for some opening brackets
    num_open = 0
    For i = start_from To Len(line)
        If Mid(line, i, 1) = ")" Then
           num_open = num_open - 1
           If num_open = 0 Then
              'Found the closing brackets
              find_closing_brackets = i
              Exit Function
           End If
        Else
           If Mid(line, i, 1) = "(" Then
              num_open = num_open + 1
           End If
        End If
    Next
End Function
Private Sub add_function(calling_function As Variant, called_function As Variant, line_number As Integer)
    'Add a function to the functions array. If the function already exists, just add the line number
    If called_function = "" Then
        Exit Sub
    End If
    
    empty_found = False
    Counter = UBound(functions)
    
    For i = 1 To Counter
        If functions(i).called_function = called_function And functions(i).calling_function = calling_function Then
            functions(i).line_number = functions(i).line_number & "," & Str(line_number)
            Exit Sub
        End If
    Next
    
    For i = 1 To Counter
        If functions(i).called_function = "" And functions(i).calling_function = "" Then
            Counter = i
            empty_found = True
            Exit For
        End If
    Next
    
    If empty_found = False Then
       ReDim Preserve functions(UBound(functions) + 1)
       Counter = UBound(functions)
    End If
    
    If IsNumeric(called_function) Then
       Exit Sub
    End If
    
    functions(Counter).called_function = called_function
    functions(Counter).calling_function = calling_function
    functions(Counter).line_number = line_number
    functions(Counter).parsed = False
End Sub
Private Sub cmdExit_Click()
    End
End Sub

Private Sub cmdOpenFile_Click()
   ' CancelError is True.
   On Error GoTo ErrHandler
   ' Set filters.
   cmdOpenFileDialog.Filter = "m-Files (*.m)|*.m|All Files (*.*)|*.*"   ' Specify default filter.
   cmdOpenFileDialog.FilterIndex = 2   ' Display the Open dialog box.
   cmdOpenFileDialog.ShowOpen    ' Call the open file procedure.
   txtFileName.Text = cmdOpenFileDialog.FileName
   If txtFileName.Text <> "" Then
      Call cmdParse_Click
   End If
   
ErrHandler:
' User pressed Cancel button.   Exit Sub
End Sub

Private Sub cmdParse_Click()

    'Start parsing the file
    'Insert the base function into the array
    fname = txtFileName.Text
    If (Right(fname, 2)) <> ".m" Then
       fname = fname & ".m"
    End If
       
    If InStrRev(fname, "\") Then
        fname = Right(fname, Len(fname) - InStrRev(fname, "\"))
    End If
    
    ReDim functions(1)
    functions(1).called_function = fname
    functions(1).line_number = 0
    functions(1).parsed = False
    
    parse_the_files
    
  
End Sub

Private Sub Form_Load()
    operand = "=+-*^~&/<>\|':, "
    trvFiles.ImageList = imgList
    
    Load frmOptions
    Load frmSplash
    frmSplash.show 0
    
    'Open INI file
    On Error GoTo no_ini
    Open "tree_builder.ini" For Input As 1
    While Not (EOF(1))
        Line Input #1, s
        If Left(s, 14) = "Matlab Pathdef" Then
           frmOptions.txtMatlabDirectory.Text = Trim(Right(s, Len(s) - 16))
        End If
    Wend
    Close

    matlab_dirs_file = frmOptions.txtMatlabDirectory.Text
        
no_ini_resume:

    On Error GoTo no_discardables
    function_type = ""
    ReDim discardable(0)
    Open "discardables.txt" For Input As 1
    While Not (EOF(1))
        Line Input #1, s
        If Left(s, 1) = "%" Then
            function_type = Right(s, Len(s) - 1)
        Else
            ReDim Preserve discardable(UBound(discardable) + 1)
            discardable(UBound(discardable)).function_name = s
            discardable(UBound(discardable)).function_type = function_type
        End If
    Wend
    
    Close 1
    
no_discardables:
Exit Sub

no_ini:
If CurDir <> "e:\work\trees" Then
 ChDir "e:\work\trees"
 ChDrive "e"
 Resume 0
Else
 GoTo no_ini_resume
End If
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

Private Sub mnuHelpAbout_Click()
    Load frmAbout
    frmAbout.show 1
    
    Unload frmAbout
End Sub

Private Sub mnuOptionsOptions_Click()

    frmOptions.show
    
End Sub



Private Sub txtFileName_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
       Call cmdParse_Click
    End If
End Sub
