function  [no,nc,ins] = brackets(str,cho,chc,chex)

% BRACKETS

%  Kirill K. Pankratov, kirill@plume.mit.edu
%  12/09/94


 % Defaults
chodflt = '(';       % Default for open character
chexdflt = 1000.55;  % Default for exclusion character (none)

 % Handle input ...................
if nargin < 4, chex = chexdflt; end
if nargin < 2, cho = chodflt; end
if nargin < 3, chc = cho+2-(cho=='('); end

 % Unwind the input string
str = str';
str = [' ' str(:)' ' '];
lstr = length(str)-2;

 % Initialize output
ins = zeros(1,lstr);
no = []; nc = [];

 % Find opening and closing characters
numbo = find(str==cho);         % Open
numbc = [find(str==chc) lstr];  % Close

if numbo~=[]
  % Exclude those preceeded by exclusion character
  % (such as '\' in LaTeX)
  numbo = numbo(str(numbo-1)~=chex);   % Open
  nbo = length(numbo);
  numbc = numbc(str(numbc-1)~=chex);   % Close
  nbc = length(numbc);
  numbc = numbc(1:nbc-1);
  nbc = nbc-1;

  numbc = [numbc lstr*ones(1,nbo-nbc)];
  nbc = length(numbc);

  [num,ind] = sort([numbo numbc]);
  a = -ones(size(num));
  a(1:nbo) = ones(1,nbo);
  a = a(ind);
  a = cumsum(a)+(a==-1);
  [a,ind] = sort(a);
  num = num(ind);
  num = reshape(num,2,length(num)/2);
  [a,ind] = sort(num(1,:));
  num = num(:,ind)-1;

  % Output
  no = num(1,:);
  nc = num(2,:);
  ins(no) = ones(1,nbo);
  ins(nc) = -ones(1,nbo);
  ins = cumsum(ins);

end
