function  list = extract(v,no,nc,nfill)

% EXTRACT  Extract entries from vector into a list (matrix)
%      LIST = EXTRACT(V,NO,NC,NFILL)
%        extracts entries from vector V starting from
%        numbers NO and until next NC into a matrix LIST
%        so that each row of LIST contains one entry;
%        put numbers NFILL (such as blanks for string)
%        at the end to make all rows of equal length.

%  Kirill K. Pankratov,  kirill@plume.mit.edu
%  8-22-94

nfilldflt = [0 32]; % Defaults for filling (0 for numbers
                    % or blank for strings)

 % Handle input ...........................................
if nargin<4, nfill = nfilldflt(1+isstr(v)); end
v = [v(:); v(1)];
lv = length(v);
no = [no(:); lv];
nc = nc(:);

lo = length(no);
lc = length(nc);
l = lo+lc;
[num,a] = sort([no; nc]);
d = num(2:l)-num(1:l-1);
a = a<lo;
d = d(a(1:l-1));
lline = max(d);
nlines = length(d);
num = cumsum(d);
l = num(nlines);

nout = ones(l,1);
nout(num+1) = lline-d+1;
nout = cumsum(nout(1:l));

nin = ones(l,1);
nin(num+1) = no(2:nlines+1)-no(1:nlines)-d+1;
nin = no(1)-1+cumsum(nin(1:l));

list = ones(lline,nlines)*nfill;
list(nout) = v(nin);

list = list';
