function  [inl,mask_q,mask_c] = findquot(string)

% FINDQUOT  String-processing utility.
%	[INL,MASK_Q,MASK_C] = FINDQUOT(STRING)
%	Returns pointers to new line characters, quote mask,
%	and comment mask.

%  Kirill K. Pankratov, kirill@plume.mit.edu
%  12/26/94

 % Determine the new line character .........................
ch_nl = [10 13];  % New line characters

 % Legal char. before beginning of string
ch_str = [' '':;,+-*\/=><([' ch_nl]';

 % Make string a row vector
string = string';
string = string(:)';

 % New lines and line numbering .........
[inl,mask_c] = findnl(string);


 % Find explicit strings (inside single quotes) .....
fnd_sq = find(string=='''');   % Pointers to single quotes
l_sq = length(fnd_sq);
ol = ones(1,l_sq);

mask_q = zeros(size(string));
if l_sq
  % Find those preceded by legal character
  o_str = ones(size(ch_str));
  a00 = any(string(o_str,fnd_sq-1)==ch_str(:,ol));
  [a0,a] = sort([fnd_sq inl+.5]);
  ind = floor(a0)==a0;
  a0 = zeros(size(a0));

  a0(ind) = a00;
  a00 = a0;
  a1 = a0;
  ll = length(a0);
  stop = 0;
  while ~stop
    a1(2:ll) = a00(2:ll)&~a0(1:ll-1);
    stop = all(a1==a0);
    a0 = a1;
  end

  a1 = a1(ind);    % Extract single quotes only
  ind = find(a1);  % Beginnings of strings

  % Calculate mask for strings
  mask_q = zeros(size(string));
  mask_q(fnd_sq(ind)) = ones(size(ind));
  ind = min(ind+1,length(fnd_sq));
  mask_q(fnd_sq(ind)) = -ones(size(ind));
  mask_q = cumsum(mask_q);

end

 % Find comments ...................................
fnd_cm = find(string=='%');       % Find comments char.
fnd_cm = fnd_cm(~mask_q(fnd_cm)); % Exclude those inside strings

 % Find first comment char. on each line
ind = mask_c(fnd_cm);
a0 = zeros(1,length(inl)+1);
a0(fliplr(ind)) = fliplr(fnd_cm);
ind = find(a0);
a0 = a0(ind);

 % Mask for comments ..................
mask_c = zeros(size(mask_c));
mask_c(a0) = ones(size(a0));
mask_c(inl(ind)) = -ones(size(ind));
mask_c = cumsum(mask_c);

 % Remove strings inside comments .....
mask_q = mask_q&~mask_c;
