function [Triv,Math,Contr,Exim] = fnames

% FNAMES Creates matrices with standard function names
%	for REFER program.
%	[TRIV,MATH,CONTR,EXIM] = FNAMES  Returns
%	string matrices TRIV - some general language
%	commands, MATH - elementary math operators,
%	CONTR - contlol flow commands and EXIM -
%	"export-import" commands.

%  Kirill K. Pankratov, kirill@plume.mit.edu
%  02/06/95

 % "Trivia"
Triv = ['ones    '; 'zeros   '; 'rand    '; 'randn   ';
        'find    '; 'max     '; 'min     '; 'all     ';
        'any     '; 'format  '; 'sum     '; 'cumsum  ';
        'prod    '; 'cumprod '; 'length  '; 'size    ';
        'abs     '; 'log     '; 'reshape '; 'sort    ';
        'i       '; 'j       '; 'inf     '; 'nan     ';
        'eye     '; 'diag    '; 'fliplr  '; 'flipud  ';
        'function'; 'nargin  '; 'nargout '; 'script  ';];

 % "Math" - some elementary math functions
Math = ['abs  '; 'acos '; 'acosh'; 'acot '; 'acoth';
        'ascc '; 'acsch'; 'asec '; 'asech'; 'asin ';
        'asinh'; 'atan '; 'atan2'; 'atanh'; 'ceil ';
        'conj '; 'cos  '; 'cosh '; 'cot  '; 'coth ';
        'csc  '; 'csch '; 'exp  '; 'fix  '; 'floor';
        'imag '; 'log  '; 'log10'; 'real '; 'rem  ';
        'round'; 'sec  '; 'sech '; 'sign '; 'sin  ';
        'sinh '; 'sqrt '; 'tan  '; 'tanh '; 'pi   '];

 % "Controls"
Contr = ['for   '; 'while '; 'if    '; 'else  ';
         'elseif'; 'end   '; 'break '; 'return'];

 % "Export-import"
Exim = ['load   '; 'fprintf'; 'fread  '; 'fscanf ';
        'save   '; 'fwrite '; 'eval   '; 'feval  '];
